#include <iostream>

using namespace std;

long long manje(long long a, long long b){

    if(a < b) return a;

    return b;

}

int main()
{

    int n, q;
    cin >> n  >> q;

    long long d[n], p[n];

    long long k[n];

    for(int i = 0; i < n; i++){

        cin >> d[i] >> p[i];

    }

    for(int i = 0; i < q; i++){

        cin >> k[i];

    }

    for(int i = 0; i < q; i++){

        int j = 0;

        long long tr = 0;

        long long res = 0;

        if(k[i] >= d[0]){

            while(j < n - 1 && d[j+1] < k[i]){

                tr += p[j];

                res += manje(d[j+1] - d[j], tr);

                tr -= manje(d[j+1] - d[j], tr);

                j ++;
            }

            tr += p[j];

            res += manje(k[i] - d[j] + 1, tr);

        }

        cout << res << endl;

    }

}